# Read press release identifiers and complexity variables into dataset

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#When opening .txt file in excel make sure to choose 'utf-8' encoding!!!!!!!!!!!!!!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

import os, os.path
import sys
import re
import nltk, string
from textstat.textstat import textstat
from nltk.tokenize import RegexpTokenizer
from nltk.stem.porter import PorterStemmer
from nltk.corpus import stopwords
from nltk.util import ngrams
from nltk.tokenize import StanfordTokenizer
from nltk.tag.stanford import StanfordNERTagger
from collections import Counter

#Load Stanford NER Tagger
os.environ['JAVAHOME'] = "C:/Program Files/Java/jre1.8.0_31/bin/java.exe"
os.environ['CLASSPATH'] = "C:/Users/nguest/Dropbox (MIT)/Research/007 - Reporters as Analysts/Data/Analysis/stanford-postagger/stanford-postagger.jar"
path_to_model = "C:/Users/nguest/Dropbox (MIT)/Research/007 - Reporters as Analysts/Data/Analysis/stanford-ner/classifiers/english.muc.7class.distsim.crf.ser.gz"
path_to_jar = "C:/Users/nguest/Dropbox (MIT)/Research/007 - Reporters as Analysts/Data/Analysis/stanford-ner/stanford-ner.jar"
st = StanfordNERTagger(path_to_model, path_to_jar)

#Access folder with press release text
path = os.path.join(r'C:\Users\nguest\Dropbox (MIT)\Research\007 - Reporters as Analysts\Data\Press Releases\SEC_EDGAR\CleanedFilings')

dlm='\t'

################################################
###Read file names into dataset
################################################
##
##g=open('PressReleases.txt', 'w', encoding='utf-8')
##g.write('gvkeyC' + dlm + 'cikC' + dlm + 'fname' + dlm + 'exname' + dlm + 'myfname' + dlm + '\n')
##
##n=0
##for myfname in os.listdir(path):
##    pieces = [m.start() for m in re.finditer('_', myfname)]
##    gvkey = myfname[0:pieces[0]]
##    gvkeyC = 'b' + myfname[0:pieces[0]]
##    cik = myfname[pieces[0]+1:pieces[1]]
##    cikC = 'b' + myfname[pieces[0]+1:pieces[1]]
##    fname0 = myfname[pieces[1]+1:pieces[2]]
##    fname = 'edgar/data/' + cik + '/' + fname0[0:10] + "-" + fname0[10:12] + "-" + fname0[12:18] + '.txt'
##    exname0 = re.findall('(.+)\.txt', myfname[pieces[2]+1:])[0]
##    exname = exname0[0:exname0.rfind('_')] + '.' + exname0[exname0.rfind('_')+1:]
##
##    #Create row for each filing
##    g.write(gvkeyC + dlm + cikC + dlm + fname + dlm + exname + dlm + myfname + dlm + '\n')
##    #Move to next filing
##    n+=1
##
##    if n % 1000 == 0:
##        print(str(n))
##
###Close data file
##g.close()



##############################################
#Text analysis on each press release
##############################################

###First time
##d=open('PressReleasesData.txt', 'w', encoding='utf-8')
##d.write('gvkeyC' + dlm + 'cikC' + dlm + 'fname' + dlm + 'exname' + dlm + 'myfname' + dlm +
##        'length' + dlm + 'readability' + dlm + 'specificity' + dlm + 'hsmix' + dlm + '\n')
#Thereafter
d=open('PressReleasesData.txt', 'a', encoding='utf-8')

#Import list of files
infile = open('PressReleases.txt', 'r', encoding='utf-8')
infile1 = infile.read().split('\n')

i=150001
while i<=174618: 
    infile2 = infile1[i].split('\t')
    gvkeyC = infile2[0]
    cikC = infile2[1]
    fname = infile2[2]
    exname = infile2[3]
    myfname = infile2[4]

    #################
    #Measure complexity#
    #################
    file = open(os.path.join(path, myfname), 'r', encoding='utf-8')
    filecontent = file.read().split("\n\n")

    ############ Length ############
    #Extract only word characters
    txt = ' '.join(str(d) for d in filecontent)
    twordlist = RegexpTokenizer(r'[a-zA-Z]+').tokenize(txt)
    length = len(twordlist)
    
    #Readability
    if textstat.lexicon_count(txt) > 0:
        readability = round(textstat.gunning_fog(txt),1)
    else:
        readability = 0

    #Specificity
    token = StanfordTokenizer().tokenize(txt)
    tagged = st.tag(token)
    taggedO = []
    for token in tagged:
        if token[1] != 'O':
            taggedO.append(token)
    if len(tagged) > 0:
        specificity = round((len(taggedO)*1000)/len(tagged),1)
    else:
        specificity = 0
    
    #Hard-Soft Mix
    nodate = []
    for token in tagged:
        if token[1] != 'DATE':
            nodate.append(token[0])
    nodate1 = ' '.join(str(d) for d in nodate)
    numbers = re.findall('(?:^|[\$\s])(\d[\d\.\,\/]*)(?:$|[\%\s])', nodate1)
    if len(tagged) > 0:
        hsmix = round((len(numbers)*1000)/len(tagged),1)
    else:
        hsmix = 0



    #Create row for each filing
    d.write(gvkeyC + dlm + cikC + dlm + fname + dlm + exname + dlm + myfname + dlm +
            str(length) + dlm + str(readability) + dlm + str(specificity) + dlm + str(hsmix) + dlm + '\n')
    #Move to next filing
    i+=1

    if i % 100 == 0:
        print(str(i))

#Close data files
infile.close()
d.close()





