# Compare Media Coverage and Press Releases

import os, os.path
import sys
import nltk, string
from nltk.tokenize import RegexpTokenizer
from nltk.stem.porter import PorterStemmer
from nltk.corpus import stopwords
import numpy as np
import re

#Load list of McDonald's "generic" and "dates and numbers" stop words expanded with 100 most common English words
stopwords = open("StopWords.txt")
stopwordsu = list(set(stopwords.read().split()))
#Load Loughran-McDonald negative words
negwords = open("LM_negwords.txt").read().split()
#http://www3.nd.edu/~mcdonald/Word_Lists.html
#Load Porter's stemming algorithm
porter = PorterStemmer()

dlm='\t'
#Create file for storing article data
###First time
##g=open('AnalyzedMatches.txt', 'w', encoding='utf-8')
##g.write('gvkey' + dlm + 'permco' + dlm + 'cik' + dlm + 'company_name' + dlm + 'pc_fname' + dlm + 'pcdate' + dlm + 'pr_fname' + dlm + 'prdate' + dlm +
##        'PCtotal_words' + dlm + 'PCtotal_words_reduced' + dlm + 'PCunique_words' + dlm + 'PCnegativity' + dlm +
##        'PRtotal_words' + dlm + 'PRtotal_words_reduced' + dlm + 'PRunique_words' + dlm + 'PRnegativity' + dlm +
##        'similarity' + dlm + '\n')
#Thereafter
g=open('AnalyzedMatches.txt', 'a', encoding='utf-8')

#Import list of matches
infile = np.recfromcsv(r'C:\Users\nguest\Dropbox (MIT)\Research\007 - Reporters as Analysts\Data\Analysis\MatchPRandPC.csv', delimiter=",")

i=311001 #Match counter
while i<=605771: #605771
    try:
        #Match IDs
        gvkey = str(infile[i][0])
        permco = str(infile[i][1])
        cik = str(infile[i][2])
        company_name = infile[i][3].decode("utf-8")
        pc_fname = infile[i][6].decode("utf-8")
        pcdate = str(infile[i][4])
        pr_fname = infile[i][7].decode("utf-8")
        prdate = str(infile[i][5])

        #Load both documents
        pcpath = os.path.join(r'C:\Users\nguest\Dropbox (MIT)\Research\007 - Reporters as Analysts\Data\Media Coverage\Articles\WSJ', infile[i][6][1:].decode("utf-8"))
        pc = open(pcpath, 'r', encoding='utf-8')
        pccontent = pc.read().split("\n")

        prpath = os.path.join(r'C:\Users\nguest\Dropbox (MIT)\Research\007 - Reporters as Analysts\Data\Press Releases\SEC_EDGAR\CleanedFilings', infile[i][7].decode("utf-8"))
        pr = open(prpath, 'r', encoding='utf-8')
        prcontent = pr.read().split("\n\n")

        #############################
        #Prepare media coverage text
        #############################
##        #Headline
##        headline = pccontent[0].split(": ")[1]
##        #Author
##        authors = pccontent[1].split(": ")[1]
##        #Date
##        date = pccontent[2].split(": ")[1]
##        #Source #Takes up a lot of space
##        #source = pccontent[3].split(": ")[1] 
##        #Medium
##        medium = pccontent[4].split(": ")[1]
##        #Position
##        position = pccontent[5].split(": ")[1]

        #Text
        PCpars = pccontent[8:]
        PCtxt = ' '.join(str(d) for d in PCpars)
        #Convert all characters to lowercase
        PCtxt = PCtxt.lower()
        #Extract only word characters
        PCtwordlist = RegexpTokenizer(r'[a-z]+').tokenize(PCtxt)

        #Identify percentage of negative words
        PCtwords=len(PCtwordlist)
        PCnwords = len([t for t in PCtwordlist if t in negwords])
        if PCtwords>0:
            PCneg = round(PCnwords/PCtwords, 5)
        else:
            PCneg = 0
        
        #Stem using the Porter algorithm
        PCporter_stemmed = [porter.stem(token) for token in PCtwordlist]
        #Remove common words
        PCtwordlistR = [t for t in PCporter_stemmed if t not in stopwordsu]
        
        #Identify total words and unique words
        PCtwordsR = len(PCtwordlistR)
        PCuwordlist = list(set(PCtwordlistR))
        PCuwords = len(PCuwordlist)


        #############################
        #Prepare press release text
        #############################
        #Text
        PRpars = prcontent
        PRtxt = ' '.join(str(d) for d in PRpars)
        #Convert all characters to lowercase
        PRtxt = PRtxt.lower()
        #Extract only word characters
        PRtwordlist = RegexpTokenizer(r'[a-z]+').tokenize(PRtxt)

        #Identify percentage of negative words
        PRtwords=len(PRtwordlist)
        PRnwords = len([t for t in PRtwordlist if t in negwords])
        if PRtwords>0:
            PRneg = round(PRnwords/PRtwords, 5)
        else:
            PRneg = 0
        
        #Stem using the Porter algorithm
        PRporter_stemmed = [porter.stem(token) for token in PRtwordlist]
        #Remove common words
        PRtwordlistR = [t for t in PRporter_stemmed if t not in stopwordsu]
        
        #Identify total words and unique words
        PRtwordsR = len(PRtwordlistR)
        PRuwordlist = list(set(PRtwordlistR))
        PRuwords = len(PRuwordlist)


        #############################
        #Calculate similarity following Tetlock (2011)
        #############################
        intersection= len([t for t in PCuwordlist if t in PRuwordlist])
        union= len(set(PCuwordlist + PRuwordlist))
        if union>0:
            sim=intersection/union
        else:
            sim=0

        #Create row for each match
        g.write(gvkey + dlm + permco + dlm + cik + dlm + company_name + dlm + pc_fname + dlm + pcdate + dlm + pr_fname + dlm + prdate + dlm +
                str(PCtwords) + dlm + str(PCtwordsR) + dlm + str(PCuwords) + dlm + str(PCneg) + dlm +
                str(PRtwords) + dlm + str(PRtwordsR) + dlm + str(PRuwords) + dlm +  str(PRneg) + dlm +
                str(sim) + dlm + '\n')
        
        #Move to next match
        i+=1
        if i % 1000 == 0:
            print(i)

    except FileNotFoundError:
        #Match IDs
        gvkey = str(infile[i][0])
        permco = str(infile[i][1])
        cik = str(infile[i][2])
        company_name = infile[i][3].decode("utf-8")
        pc_fname = infile[i][6].decode("utf-8")
        pcdate = str(infile[i][4])
        pr_fname = infile[i][7].decode("utf-8")
        prdate = str(infile[i][5])

        PCtwords=''
        PCtwordsR=''
        PCuwords=''
        PCneg=''
        PRtwords=''
        PRtwordsR=''
        PRuwords=''
        PRneg=''
        sim=''

        g.write(gvkey + dlm + permco + dlm + cik + dlm + company_name + dlm + pc_fname + dlm + pcdate + dlm + pr_fname + dlm + prdate + dlm +
                PCtwords + dlm + PCtwordsR + dlm + PCuwords + dlm + PCneg + dlm +
                PRtwords + dlm + PRtwordsR + dlm + PRuwords + dlm + PRneg + dlm +
                sim + dlm + '\n')
        
        i+=1
        if i % 1000 == 0:
            print(i)

#Close data file
g.close()


#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#When opening .txt file in excel make sure to choose 'utf-8' encoding!!!!!!!!!!!!!!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



